//*****************************************************
//
// Linhas.cpp 
// Um programa OpenGL simples que abre uma janela GLUT 
// e faz o desenho de algumas linhas com cores, estilos 
// e espessuras diferentes
//
// Marcelo Cohen e Isabel H. Manssour
// Este cdigo acompanha o livro 
// "OpenGL - Uma Abordagem Prtica e Objetiva"
// 
//*****************************************************

#include <stdlib.h>
#include <GL/glut.h>
    
// Funo callback de redesenho da janela de visualizao
void Desenha(void) 
{
	// Limpa a janela de visualizao com a cor  
	// de fundo definida previamente
	glClear(GL_COLOR_BUFFER_BIT);

	// Habilita a alterao do estilo das linhas
	glEnable(GL_LINE_STIPPLE);

	// Altera a cor do desenho para vermelho
	glColor3f(1.0f, 0.0f, 0.0f);

	// Altera a espessura da linha
	glLineWidth(0.8);

	// Altera o estilo da linha 
	glLineStipple(1, 0xFFFF);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, 40.0f);
		glVertex2f(40.0f, 40.0f);
	glEnd();

	// Altera a cor do desenho para verde
	glColor3f(0.0f, 1.0f, 0.0f);

	// Altera a espessura da linha
	glLineWidth(1.6);

	// Altera o estilo da linha 
	glLineStipple(4, 0x1F2F);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, 30.0f);
		glVertex2f(40.0f, 30.0f);
	glEnd();

	// Altera a cor do desenho para azul
	glColor3f(0.0f, 0.0f, 1.0f);
    
	// Altera a espessura da linha
	glLineWidth(2.4);
    
	// Altera o estilo da linha 
	glLineStipple(1, 0x01010);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, 20.0f);
		glVertex2f(40.0f, 20.0f);
	glEnd();

	// Altera a cor do desenho para preto
	glColor3f(0.0f, 0.0f, 0.0f);

	// Altera a espessura da linha
	glLineWidth(3.2);

	// Altera o estilo da linha 
	glLineStipple(2, 0xF020);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, 10.0f);
		glVertex2f(40.0f, 10.0f);
	glEnd();

	// Altera a cor do desenho para magenta
	glColor3f(1.0f, 0.0f, 1.0f);

	// Altera a espessura da linha
	glLineWidth(4.0);

	// Altera o estilo da linha 
	glLineStipple(3, 0x00FF);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, 0.0f);
		glVertex2f(40.0f, 0.0f);
	glEnd();

	// Altera a cor do desenho para preto
	glColor3f(0.0f, 0.0f, 0.0f);

	// Altera a espessura da linha
	glLineWidth(4.8);

	// Altera o estilo da linha 
	glLineStipple(3, 0x0F0F);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, -10.0f);
		glVertex2f(40.0f, -10.0f);
	glEnd();

	// Altera a cor do desenho para azul
	glColor3f(0.0f, 0.0f, 1.0f);

	// Altera a espessura da linha
	glLineWidth(5.6);

	// Altera o estilo da linha 
	glLineStipple(5, 0x5555);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, -20.0f);
		glVertex2f(40.0f, -20.0f);
	glEnd();

	// Altera a cor do desenho para verde
	glColor3f(0.0f, 1.0f, 0.0f);

	// Altera a espessura da linha
	glLineWidth(6.4);

	// Altera o estilo da linha 
	glLineStipple(1, 0x3F07);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, -30.0f);
		glVertex2f(40.0f, -30.0f);
	glEnd();

	// Altera a cor do desenho para vermelho
	glColor3f(1.0f, 0.0f, 0.0f);
    
	// Altera a espessura da linha
	glLineWidth(7.2);
    
	// Altera o estilo da linha 
	glLineStipple(4, 0x3F07);
	glBegin(GL_LINES);
		glVertex2f(-40.0f, -40.0f);
		glVertex2f(40.0f, -40.0f);
	glEnd();

	// Executa os comandos OpenGL 
	glFlush();
	
}

// Funo callback chamada quando o tamanho da janela  alterado 
void AlteraTamanhoJanela(GLsizei w, GLsizei h) 
{
	// Evita a divisao por zero
	if (h == 0) {
		h = 1;
  }

	// Especifica as dimenses da Viewport
	glViewport(0, 0, w, h);

	// Inicializa o sistema de coordenadas
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Estabelece a janela de seleo (esquerda, direita, inferior, 
	// superior) mantendo a proporo com a janela de visualizao
	if (w <= h) {
		gluOrtho2D(-50.0f, 50.0f, -50.0f * h / w, 50.0f * h / w);
  }
	else {
		gluOrtho2D(-50.0f * w / h, 50.0f * w / h, -50.0f, 50.0f);
  }
}

// Funo callback chamada para gerenciar eventos de teclas
void Teclado (unsigned char key, int x, int y)
{
	if (key == 27)
	{
		exit(0);
  }
  
}

// Funo responsvel por inicializar parmetros e variveis
void Inicializa(void) 
{
	// Define a cor de fundo da janela de visualizao como branca
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
} 

// Programa Principal 
int main(void) 
{
	// Define do modo de operao da GLUT
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);

	// Especifica a posio inicial da janela GLUT
	glutInitWindowPosition(5, 5);

	// Especifica o tamanho inicial em pixels da janela GLUT
	glutInitWindowSize(450, 450);

	// Cria a janela passando como argumento o ttulo da mesma
	glutCreateWindow("Desenho de Linhas");

	// Registra a funo callback de redesenho da janela de visualizao
	glutDisplayFunc(Desenha);

	// Registra a funo callback de redimensionamento da janela de visualizao
	glutReshapeFunc(AlteraTamanhoJanela);

	// Registra a funo callback para tratamento das teclas ASCII
	glutKeyboardFunc (Teclado);

	// Chama a funo responsvel por fazer as inicializaes 
	Inicializa();

	// Inicia o processamento e aguarda interaes do usurio
	glutMainLoop();

	return 0;
}
