//*****************************************************
//
// PadroesDePoligonos.cpp 
// Um programa OpenGL simples que abre uma janela GLUT 
// e faz o desenho de alguns polgonos preenchidos com 
// diferentes padres.
//
// Marcelo Cohen e Isabel H. Manssour
// Este cdigo acompanha o livro
// "OpenGL - Uma Abordagem Prtica e Objetiva"  
// 
//*****************************************************

#include <stdlib.h>
#include <GL/glut.h>

// Funo callback de redesenho da janela de visualizao
void Desenha(void)
{
	GLubyte padrao1[] = {
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00,
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00,
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00,
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00,
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00,
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00,
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 
	0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 
	0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00             
	};
     
	GLubyte padrao2[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,    
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,     
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,     
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,      
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,     
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,      
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,     
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,       
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA  
	};
      
	GLubyte padrao3[] = {
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 
	};
	
	// Limpa a janela de visualizao com a cor  
	// de fundo definida previamente
	glClear(GL_COLOR_BUFFER_BIT);

	// Habilita a alterao do estilo das linhas
	glEnable(GL_POLYGON_STIPPLE);
     
	// Altera a cor do desenho para preto
	glColor3f(0.0f, 0.0f, 0.0f); 

	// Altera o padrao de preenchimento do polgono 
	// (chamin da casa)
	glPolygonStipple(padrao1);     
	glBegin(GL_POLYGON);
		glVertex2f(15.0f,28.0f);
		glVertex2f(15.0f,45.0f);
		glVertex2f(25.0f,45.0f);
		glVertex2f(25.0f,21.0f);        
	glEnd(); 
        
	// Altera o padrao de preenchimento do polgono 
	// (frente da casa)
	glPolygonStipple(padrao3);     
	glBegin(GL_QUADS);
		glVertex2f(-40.0f,-40.0f);
		glVertex2f(-40.0f, 10.0f);
		glVertex2f(-10.0f, 10.0f);
		glVertex2f(-10.0f,-40.0f); 
		glVertex2f(-10.0f,-20.0f);
		glVertex2f(-10.0f, 10.0f);
		glVertex2f( 10.0f, 10.0f);
		glVertex2f( 10.0f,-20.0f); 
		glVertex2f( 10.0f,-40.0f);
		glVertex2f( 10.0f, 10.0f);
		glVertex2f( 40.0f, 10.0f);
		glVertex2f( 40.0f,-40.0f);
	glEnd();       
  
	// Altera o padrao de preenchimento do polgono 
	// (telhado da casa)
	glPolygonStipple(padrao2);     
	glBegin(GL_TRIANGLES);
		glVertex2f(-40.0f, 10.0f);
		glVertex2f(  0.0f, 40.0f);
		glVertex2f( 40.0f, 10.0f);       
	glEnd();    

	// Altera o padrao de preenchimento do polgono 
	// (porta da casa)
	glPolygonStipple(padrao2);     
	glBegin(GL_QUADS);
		glVertex2f(-10.0f,-40.0f);
		glVertex2f(-10.0f,-20.0f);
		glVertex2f( 10.0f,-20.0f);         
		glVertex2f( 10.0f,-40.0f);       
	glEnd();    

	// Executa os comandos OpenGL 
	glFlush();
}

// Funo callback chamada quando o tamanho da janela  alterado 
void AlteraTamanhoJanela(GLsizei w, GLsizei h)
{
	// Evita a divisao por zero
	if(h == 0) h = 1;
                           
	// Especifica as dimenses da Viewport
	glViewport(0, 0, w, h);

	// Inicializa o sistema de coordenadas
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Estabelece a janela de seleo (esquerda, direita, inferior, 
	// superior) mantendo a proporo com a janela de visualizao
	if (w <= h) 
		gluOrtho2D (-50.0f, 50.0f, -50.0f*h/w, 50.0f*h/w);
	else 
		gluOrtho2D (-50.0f*w/h, 50.0f*w/h, -50.0f, 50.0f);
}

// Funo callback chamada para gerenciar eventos de teclas
void Teclado (unsigned char key, int x, int y)  
{
	if (key == 27) 
		exit(0);
}


// Funo responsvel por inicializar parmetros e variveis
void Inicializa (void)
{   
	// Define a cor de fundo da janela de visualizao como branca
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
}

// Programa Principal 
int main(void)
{
	// Define do modo de operao da GLUT
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); 
 
	// Especifica a posio inicial da janela GLUT
	glutInitWindowPosition(5,5); 
    
	// Especifica o tamanho inicial em pixels da janela GLUT
	glutInitWindowSize(450,450); 
 
	// Cria a janela passando como argumento o ttulo da mesma
	glutCreateWindow("Polgonos com Diferentes Padres");
 
	// Registra a funo callback de redesenho da janela de visualizao
	glutDisplayFunc(Desenha);
  
	// Registra a funo callback de redimensionamento da janela de visualizao
	glutReshapeFunc(AlteraTamanhoJanela);

	// Registra a funo callback para tratamento das teclas ASCII
	glutKeyboardFunc (Teclado);
	
	// Chama a funo responsvel por fazer as inicializaes 
	Inicializa();
 
	// Inicia o processamento e aguarda interaes do usurio
	glutMainLoop();
 
	return 0;
}
